#include <PalmOS.h>
#include <PalmTypes.h>
#include "gui.h"

enum objecType { FORM, BUTTON, TEXTFIELD, MENUITEM, DIALOG, POPUPLIST };

/*       gui calls 
*/

DmOpenRef gui::_guiDB;
Int32 gui::_eventWait;


void gui::cleanup(){
}

void gui::setType(short Type){
   _myType=Type;
}

short gui::getType() {
   return _myType;
}

FormEventHandlerPtr gui::getEventHandler() {
   return _eventHandler;
}

DmOpenRef gui::getDB() {
   return _guiDB;
}

void gui::setEventHandler(FormEventHandlerPtr handler) {
   _eventHandler=handler;
}

UInt16 gui::setID(UInt16 refID) {
   _myID =  refID;
   _eventHandler=0;
   return _myID;
}
UInt16 gui::getID() {
   return _myID;
}

Boolean gui::isVisible(){
   return false;
}
Boolean gui::isEnabled(){
   return false;
}
void gui::setEventWait(Int32 wait) {
   _eventWait=wait;
}
UInt16 gui::getFormID() {
   return 0;
}
void gui::setFormID(UInt16 ID) { 
}


Boolean gui::eventHandlerWrapper(EventPtr event) {
    return false;
}

Boolean gui::init(int AppID) {   //  must use this to initialize gui DB
   UInt16 index = 0;
   form::init();
   _eventWait=evtWaitForever;
   _guiDB = DmOpenDatabaseByTypeCreator('Data', AppID, dmModeReadWrite);

   if (!_guiDB) {
      if (DmCreateDatabase(0, "guiDB", AppID, 'Data', true)) return 1;
      _guiDB = DmOpenDatabaseByTypeCreator('Data', AppID, dmModeReadWrite);
   }

}
Boolean gui::flush() {
   DmCloseDatabase(_guiDB);
}

void gui::MainEventLoop()
{
  form *tmpform;
  UInt16    err;
  UInt32    formID;
  FormPtr   formptr;
  EventType event;
  do
  {
 
    EvtGetEvent(&event, _eventWait);

    if (SysHandleEvent(&event)) continue;
    if (MenuHandleEvent(0, &event, &err)) continue;

    if (event.eType == frmLoadEvent)
    {
      formID = event.data.frmLoad.formID;
      tmpform=form::getFormByID(formID);
      form::setActiveForm(tmpform);
      form::allEvents(&event);
    }
    FrmDispatchEvent(&event);
      
  } while(event.eType != appStopEvent);
  form::flush();
  gui::flush();
}

   
/***********   form methods and fields   */

form *form::_curForm;
UInt16 form::_formIDs[MAXFORMS];
form *form::_forms[MAXFORMS];
int form::_numForms;


form::form(int ID){
   int indx;
   form::setID(ID);
   gui::setType(FORM);
   _numguis=0;
   for (  indx=0; indx < MAXEVENTHNDLRS; indx++ ) { _E[indx]=0; }
}
form *form::getCurrentForm() {
   return _curForm;
}

void form::init() {
   int indx;
   _curForm=0;
   _numForms=0;
   for( indx=0; indx < MAXFORMS; indx++ ) {
      _formIDs[indx]=0;
      _forms[indx]=0;
   }
}
   

void form::flush(){
   int index;
   _curForm=0;
              // now chain to cleanup routines of each form
   for (index=0 ; index< _numForms ; index++) { _forms[index]->cleanup(); }
}

void form::cleanup() {  // chain to cleanup routines of each object
   int index;
   frmobject *curobj;
   for (index=0 ; index< _numguis ; index++) {
      curobj= (frmobject *) _E[index];
      curobj->cleanup();
   }
}


Boolean form::eventHandlerWrapper(EventPtr event) {
   FormEventHandlerPtr handler;
   Boolean handled=false;
   form *newform;
   FormPtr form;
   switch(event->eType) {
      case frmGotoEvent:
          if ( event->data.frmGoto.formID == _curForm->getID() ) {
              handler=_curForm->getEventHandler();
              if ( handler != 0 ) { handled=(*handler)(event); }
          }
          break;
//      case frmLoadEvent:
//          if ( event->data.frmLoad.formID == _curForm->getID() ) {
//              handler=_curForm->getEventHandler();
//              form::setActiveForm(_curForm);
//              if ( handler != 0 ) { (*handler)(event); }
//          }
//          else {
//             newform = form::getFormByID(event->data.frmLoad.formID );
//             form::setActiveForm(newform);
//             handler=newform->getEventHandler();
//             if ( handler != 0 ) { (*handler)(event); }
//          }
//          handled=true;
//          break;

      case frmOpenEvent:
          if ( event->data.frmLoad.formID == _curForm->getID() ) {
              form = FrmGetActiveForm();
              FrmDrawForm(form);
              handler=_curForm->getEventHandler();
              if ( handler != 0 ) { handled=(*handler)(event); }

          }
          break;
      case frmCloseEvent:
          if ( event->data.frmClose.formID == _curForm->getID() ) {
              handler=_curForm->getEventHandler();
              if ( handled != 0 ) { handled=(*handler)(event); }
          }
          break;
      case nilEvent:
          if ( event->data.frmClose.formID == _curForm->getID() ) {
              handler=_curForm->getEventHandler();
              if ( handled != 0 ) { handled=(*handler)(event); }
          }
          break;
   }
   return handled;
}

int form::add(guiPtr g){ 
   _E[_numguis] = g;
   _numguis++;
}

Boolean form::callEvents(EventPtr event) {
   int index;
   gui *curobj;
   Boolean handled;
   for (index=0 ; index< _numguis ; index++) {
      curobj = (gui *) _E[index];
      handled=curobj->eventHandlerWrapper(event);
   }
   if (! handled) { handled=this->eventHandlerWrapper(event); }
   return handled;
}
Boolean form::allEvents(EventPtr event) {
    Boolean handled=false;
    form *test;
    test=_curForm;
    if ( test != 0 ) {
        handled=_curForm->callEvents(event);
    }
    return handled;
}

Boolean form::setActiveForm(form *aform) {
    FormPtr formptr;
    formptr = FrmInitForm(aform->getID());
    FrmSetActiveForm(formptr);
    FrmSetEventHandler(formptr, (FormEventHandlerPtr) form::allEvents);
    _curForm=aform;
    aform->setFormID(aform->getID());
    return true;
}

void form::setFormID( UInt16 ID ) {
    int indx;
    frmobject *curobj;
    UInt16 myID;
    myID=this->getID();
    for ( indx=0; indx < _numguis; indx++) {
       curobj=(frmobject *) _E[indx];
       curobj->setFormID(myID);
    }
}

UInt16 form::setID(UInt16 refID) {
   gui::setID(refID);
   _formIDs[_numForms]=refID;
   _forms[_numForms]=this;
   _numForms++;
}

form *form::getFormByID(UInt16 refID) {
   int index;
   form *test;
   for ( index=0; index < _numForms; index++ ) {
       if ( _formIDs[index] == refID ) { return _forms[index]; }
   }
   return 0;
}

guiPtr form::getobjectByID(short Type, UInt16 refID) {
   int index;
   
   gui *thisgui;
   for ( index=0; index < _numguis; index++ ) {
       thisgui = (gui *) _E[index];
       if (  ( thisgui->getID() == refID ) &&
               ( thisgui->getType() == Type )  ){ return _E[index]; }
   }
   return 0;
   
}
guiPtr form::getbuttonByID(UInt16 refID) {
   int index;
   guiPtr test;
   for ( index=0; index < _numForms; index++ ) {
      test = _forms[index]->getobjectByID(BUTTON, refID);
      if ( test ) return test;
   }
   return 0;
}
guiPtr form::getlistByID(UInt16 refID) {
   int index;
   guiPtr test;
   for ( index=0; index < _numForms; index++ ) {
      test = _forms[index]->getobjectByID(POPUPLIST, refID);
      if ( test ) return test;
   }
   return 0;
}
guiPtr form::gettextfieldByID(UInt16 refID) {
   int index;
   guiPtr test;
   for ( index=0; index < _numForms; index++ ) {
      test = _forms[index]->getobjectByID(TEXTFIELD, refID);
      if ( test ) return test;
   }
   return 0;
}
guiPtr form::getmenuitemByID(UInt16 refID) {
   int index;
   guiPtr test;
   for ( index=0; index < _numForms; index++ ) {
      test = _forms[index]->getobjectByID(MENUITEM, refID);
      if ( test ) return test;
   }
   return 0;
}
guiPtr form::getdialogByID(UInt16 refID) {
   int index;
   guiPtr test;
   for ( index=0; index < _numForms; index++ ) {
      test = _forms[index]->getobjectByID(DIALOG, refID);
      if ( test ) return test;
   }
   return 0;
}

// frmobject routines - to be inherited

UInt16 frmobject::getFormID() {
   return _formID;
}
void frmobject::setFormID(UInt16 ID) {
   _formID = ID;
}

//  Control events

Boolean control::eventHandlerWrapper(EventPtr event) {
   Boolean handled=false;
   FormEventHandlerPtr handler;
   switch(event->eType) {
      case ctlSelectEvent:
          if ( event->data.ctlSelect.controlID == this->getID() ) {
              handler=this->getEventHandler();
              if ( handler != 0 ) { handled=(*handler)(event); }
              break;
          }
   }
   return handled;
}


// button
button::button(int ID) {
   gui::setID(ID);
   gui::setType(BUTTON);
}


//  Fields

textfield::textfield(int ID){
    gui::setID(ID);
    gui::setType(TEXTFIELD);
    _fieldPtr=0;
}
void textfield::cleanup() {
   FldSetTextHandle(_fieldPtr, NULL);
}
   
void textfield::setFormID(UInt16 ID) {
   frmobject::setFormID(ID);
   FormPtr formptr;
   MemHandle texthandle;
   MemPtr recPtr;

   formptr = FrmGetFormPtr(this->getFormID());
   _fieldPtr = (FieldPtr) FrmGetObjectPtr(  formptr, FrmGetObjectIndex( formptr, this->getID() )  );

   texthandle = DmGetResource('Tfld', (DmResID) this->getID());

   if ( ! texthandle ) {  // create new id it doesn't exist
      char nullstring = 0;
      texthandle = DmNewResource(gui::getDB(),'Tfld',(DmResID) this->getID(),1);
      recPtr = MemHandleLock(texthandle);
      DmWrite(recPtr, 0, &nullstring, 1);
      MemHandleUnlock(texthandle);
   }
   if ( texthandle && _fieldPtr ) {
      FldSetTextHandle(_fieldPtr, texthandle);
   }
   
}
void textfield::setText(char *newtext) {
   int len;
   Err error;
   MemPtr recPtr;
   MemHandle texthandle;
   if ( ! _fieldPtr ) {  // not initialized yet, still allow text setting

      texthandle = DmGetResource('Tfld', (DmResID) this->getID());

      if ( ! texthandle ) {  // create new id it doesn't exist
         char nullstring = 0;
         texthandle = DmNewResource(gui::getDB(),'Tfld',(DmResID) this->getID(),1);
         recPtr = MemHandleLock(texthandle);
         DmWrite(recPtr, 0, newtext, 1);
         MemHandleUnlock(texthandle);
      }
   }
   else {
      len=StrLen(newtext)+1;
      texthandle=FldGetTextHandle(_fieldPtr);
      if ( texthandle ) {
         FldSetTextHandle(_fieldPtr, NULL);  // unlocks memory chunk
         texthandle=DmResizeResource(texthandle, len);
         if (! texthandle ) { error = DmGetLastErr(); }
         if ( texthandle ) {
            recPtr = MemHandleLock(texthandle);
            DmWrite(recPtr, 0, newtext, len);
            MemHandleUnlock(texthandle);
            FldSetTextHandle(_fieldPtr, texthandle);
            FldDrawField(_fieldPtr);
         }
      }
   }
}
int textfield::textLength() {
   MemPtr recPtr;
   MemHandle texthandle;
   int length;
   if ( ! _fieldPtr ) return 0;
   texthandle=FldGetTextHandle(_fieldPtr);
   recPtr = MemHandleLock(texthandle);
   length=StrLen((char *)recPtr);
   MemHandleUnlock(texthandle);
   return length;
}

void textfield::getText(char *dst) {
   MemPtr recPtr;
   MemHandle texthandle;
   texthandle=FldGetTextHandle(_fieldPtr);
   recPtr = MemHandleLock(texthandle);
   StrCopy(dst,(char *)recPtr);
   MemHandleUnlock(texthandle);
}


//  menuitem

menuitem::menuitem(int ID){
    gui::setID(ID);
   gui::setType(MENUITEM);
}

Boolean menuitem::eventHandlerWrapper(EventPtr event) {
   Boolean handled=false;
   FormEventHandlerPtr handler;
   switch(event->eType) {
      case menuEvent:
          if ( event->data.menu.itemID == this->getID() ) {
              handler=this->getEventHandler();
              if ( handler != 0 ) { handled=(*handler)(event); }
              break;
          }
   }
   return handled;
}

// dialog
dialog::dialog(int ID) {
    gui::setID(ID);
    gui::setType(DIALOG);
    _lastAnswer=0;
}

UInt16 dialog::getAnswer(){
   return _lastAnswer;
}

void dialog::show(){
   _lastAnswer = FrmAlert( this->getID() );
}

/* PopUpList */

popuplist::popuplist(int popupID, int listID) {
    FormPtr  formptr;
    gui::setID(listID);
    gui::setType(POPUPLIST);
    _numitems=0;
    _list=0;
    _listPtr=0;
    _ctlPtr=0;
    _popID=popupID;
    _selected=0;
}

void popuplist::appendItem(char *newitem) {
    UInt16 length;
    char *newstr;
    char **temp;
    char **mylist = new Char *[_numitems+2];
    length = StrLen( newitem );
    newstr = new Char[21];
    StrCopy(newstr,newitem);
    mylist[_numitems] = newstr;
    for ( length=0; length < _numitems; length++) {
       mylist[length]=_list[length];
    }
    temp = _list;
    _list=mylist;
    if ( temp ) { delete temp; }
    if ( _listPtr > 0 ) {
       LstSetListChoices( _listPtr, _list, _numitems );
    }
    _numitems++;
       
}
void popuplist::deleteItem(int index) {
}
Boolean popuplist::eventHandlerWrapper(EventPtr event){
}
void popuplist::setFormID(UInt16 ID) {
    FormPtr formptr;
    frmobject::setFormID(ID);
    formptr = FrmGetFormPtr(this->getFormID());
    _listPtr = (ListPtr) FrmGetObjectPtr(  formptr, FrmGetObjectIndex( formptr, this->getID() )  );
    _ctlPtr = (ControlType *) FrmGetObjectPtr(  formptr, FrmGetObjectIndex( formptr, _popID )  );
    if ( _numitems > 0 ) {
       LstSetListChoices( _listPtr, _list, _numitems );
       if ( ! _selected ) {  setSelection(0);  }
    }
} 
void popuplist::setSelection(int index){
    char *seltext;
    if (( _listPtr > 0 ) && ( index < _numitems)) {
       LstMakeItemVisible( _listPtr, index);
       LstSetSelection( _listPtr, index);
       _selected=index;
       seltext = _list[index];
       CtlSetLabel( _ctlPtr, seltext );
    }
}

UInt16 popuplist::getSelected() {
    if ( _listPtr ) {
       return LstGetSelection( _listPtr );
    }
    else {
       return _selected;
    }
}

char *popuplist::getSelectionText(int index) {
    
    
    if ( _listPtr ) {           // resource loaded in memory, use resource
        return LstGetSelectionText( _listPtr, index );
    }
    else {                      // resource not in memory, use stored value
        return _list[ _selected ];
    }

}
void popuplist::cleanup() {
    int length;
    for ( length=0; length < _numitems; length++) {
          delete _list[length];
    }
    if ( _list ) { delete _list; }
}

