//#include "string.h"
#define MAXEVENTHNDLRS 20
#define MAXFORMS 10 

typedef void * guiPtr;

class gui {
public:
    virtual Boolean isVisible();
    virtual Boolean isEnabled();
    virtual UInt16 setID(UInt16 refID);
    virtual UInt16 getFormID();
    virtual FormEventHandlerPtr getEventHandler();
    virtual void setEventHandler(FormEventHandlerPtr handler);
    virtual Boolean eventHandlerWrapper(EventPtr event);
    virtual void setFormID(UInt16 ID);
    virtual void setType(short Type);
    virtual short getType();
    virtual void cleanup();
    static void MainEventLoop();
    static Boolean init(int AppID);   //  must use this to initialize gui DB
    static Boolean flush();
    static DmOpenRef getDB();
    static void setEventWait(Int32 wait);
    UInt16 getID();
private:
    UInt16 _myID;
    short _myType;
    FormEventHandlerPtr _eventHandler;
    static Int32 _eventWait;
    static DmOpenRef _guiDB;
};


class form : public gui {
public:
   form(int ID);
   static void init();              // initialize static variables
   static Boolean allEvents(EventPtr event);
   static Boolean setActiveForm(form *aform);   // Sets the active form and activates its events
   static form *getFormByID(UInt16 ID);  // get the form by reference ID
   static void flush();
   static form *getCurrentForm();
   static guiPtr getbuttonByID(UInt16 ID);
   static guiPtr getlistByID(UInt16 ID);
   static guiPtr gettextfieldByID(UInt16 ID);
   static guiPtr getmenuitemByID(UInt16 ID);
   static guiPtr getdialogByID(UInt16 ID);

   UInt16 setID(UInt16 refID);

   guiPtr getobjectByID(short Type, UInt16 refID);  // get the object by reference ID
   void setFormID(UInt16 ID);
   Boolean callEvents(EventPtr event);
   Boolean eventHandlerWrapper(EventPtr event);
   void cleanup();
   int add(guiPtr g);
private:
   static int _numForms;
   static UInt16 _formIDs[MAXFORMS];
   static form *_forms[MAXFORMS];
   static form *_curForm;

   guiPtr _E[MAXEVENTHNDLRS];
   int _numguis;

};

class frmobject : public gui {
public:
    virtual UInt16 getFormID();
    virtual void setFormID(UInt16 ID);
private:
    UInt16 _formID;  // the id of the form that owns this object
};

class textfield : public frmobject {
public:
    textfield(int ID);
    void setFormID(UInt16 ID);
    void cleanup();
    void setText(char *newtext);
    int textLength();
    
    void getText(char *dst);           
private:
   FieldPtr _fieldPtr;
};

class control : public frmobject {
public:
   virtual Boolean eventHandlerWrapper(EventPtr event);
};

class button : public control {
public:
   button(int ID);
   
//    Boolean isVisible();
//    Boolean isEnabled();
};

// class menuitem

class menuitem : public frmobject {
public:
   menuitem(int ID);
   virtual Boolean eventHandlerWrapper(EventPtr event);
};

//  dialogs

class dialog : public gui {
public:
   dialog(int ID);
   UInt16 getAnswer();
   void show();
private:
   UInt16 _lastAnswer;
};

// popuplist

class popuplist : public frmobject {
public:
   void setFormID(UInt16 ID);
   popuplist(int popID, int listID);
   void appendItem(char *);
   virtual Boolean eventHandlerWrapper(EventPtr event);
   void deleteItem(int index);  
   void setSelection(int index);
   UInt16 getSelected();
   char *getSelectionText(int index);
   void cleanup();
private:
   UInt16 _numitems;                 // number of items in list
   char **_list;                     // a pointer to the string array
   ListPtr _listPtr;                 // a pointer to the list resource
   UInt16 _popID;                    // the popuptrigger resource id
   ControlType *_ctlPtr;             // pointer to lists pop up trigger
   UInt16 _selected;                 // index to currently selected item
};
