#include <PalmOS.h>
#include <PalmTypes.h>

#define Form1ID  1000
#define appID 'TbBm'

#include "gui.h"
#include "tester.h"
#include "benchmark.h"
#include "stacktest.h"
#include "sieve.h"
#include "memswap.h"
#include "memswapdb.h"

//            Global variables


form *form1;             // the programs main form
textfield *result;       // textfield where result is displayed
button *button1;         // button to start the benchmark
menuitem *about;         // bring up an about alert through a menu
menuitem *go;            // same as button1 but in a menu
dialog *aboutdialog;     // the actual dialog
popuplist *benchlist;    // a popup list for selecting the benchmark to run


UInt16 StartApplication()
{
  UInt16 error;
  FrmGotoForm(Form1ID);
}

UInt16 StopApplication(){
   FrmCloseAllForms();
}
  
Boolean form1_startup(EventPtr event) {
    char test[]="";
    textfield *result;
    if ( event->eType == frmOpenEvent ) {
       result  = (textfield *) form::gettextfieldByID(fldID_result);
       result->setText(test);
    }
}


Boolean showaboutdialog(EventPtr event) {
   dialog *about;

   about=(dialog *)form::getdialogByID(dlgID_about);
   about->show();
}
   
     



Boolean button1_click(EventPtr event) {
   UInt16 selection;
   selection = benchlist->getSelected();
   switch ( selection ) {
      case 0: {
         stacktest *bmark=new stacktest();
         bmark->setTextField(result);
         bmark->runBenchmark();
         delete bmark;
         break;
      }
      case 1: {
         sieve *bmark=new sieve();
         bmark->runBenchmark();
         result->setText( bmark->getDuration() );
         delete bmark;
         break;
      }
      case 2: {
         memswap *bmark=new memswap();
         bmark->runBenchmark();
         result->setText( bmark->getDuration() );
         delete bmark;
         break;
      }
      case 3: {
         memswapdb *bmark=new memswapdb();
         bmark->runBenchmark();
         result->setText( bmark->getDuration() );
         delete bmark;
         break;
      }
   }
   return true;
}

UInt32  PilotMain (UInt16 cmd, MemPtr cmdPBP, UInt16 launchFlags)
{
  UInt16 error;
  char listitem[15];

  if (cmd == sysAppLaunchCmdNormalLaunch)
 {

    gui::init(appID);   // initializes gui class database
    form1=new form(Form1ID);  // declare forms as static or global
    form1->setEventHandler( (FormEventHandlerPtr) form1_startup );
    result=new textfield(fldID_result);
    
    button1=new button(btnID_go);
    button1->setEventHandler( (FormEventHandlerPtr) button1_click);

    about=new menuitem(menuitemID_about);
    about->setEventHandler( (FormEventHandlerPtr) showaboutdialog );

    go=new menuitem(menuitemID_go);
    go->setEventHandler( (FormEventHandlerPtr) button1_click );

    aboutdialog=new dialog(dlgID_about);

    benchlist = new popuplist(listID_popup,listID_benchmarks);
    
    benchlist->appendItem("Stack Test");
    benchlist->appendItem("Sieve");
    benchlist->appendItem("MemSwap");
    benchlist->appendItem("MemSwap DB");
    benchlist->setSelection(0);
    form1->add(benchlist);
    form1->add(button1);
    form1->add(result);
    form1->add(go);
    form1->add(about);
    form1->add(aboutdialog);

    error = StartApplication();	// Application start code
    if (error) return error;

    gui::MainEventLoop();	// Event loop

    StopApplication ();	// Application stop code
    delete form1;
    delete result;
    delete button1;
    delete about;
    delete go;
    delete aboutdialog;
    delete benchlist;
  }
  return 0;
}

