#include <PalmOS.h>
#include <PalmTypes.h>
#include "gui.h"
#include "benchmark.h"
#include "memswapdb.h"
#define AppID 'TbBm'
#define ARRAYSIZE 2048

memswapdb::memswapdb(){
   srand(5011971);
}

// memory swapping algorithm
void memswapdb::doBenchmark() {
   DmOpenRef msDB;
   Err error;
   LocalID fileID;
   MemHandle handle;
   MemHandle handle2;
   MemPtr intPtr;
   MemPtr intPtr2;
   static Err lastErr;
   UInt32 index;
   UInt16 rec1=0;
   UInt16 rec2=0;
   UInt32 temp=0;
   UInt16 temp16=0;

//  open a database for sorting

   fileID = DmFindDatabase(0,"memswapDB");
   if ( fileID ) {
      error = DmDeleteDatabase(0, fileID);
   }
   DmCreateDatabase(0, "memswapDB", AppID, 'Data', false);
   fileID = DmFindDatabase(0,"memswapDB");
   msDB = DmOpenDatabase(0,fileID, dmModeReadWrite);
//  initialize 16384 records
   for ( rec1=0; rec1 < ARRAYSIZE; rec1++) {
       handle = DmNewRecord( msDB, &rec1, sizeof(UInt32) );
       intPtr = MemHandleLock(handle);
       index=rec1;
       DmWrite( intPtr, 0, (void *)&index, sizeof(UInt32) );
       MemHandleUnlock(handle);
       DmReleaseRecord(msDB, rec1, false);
   }
//  swap 16384 records randomly
   for ( index=0; index < ARRAYSIZE; index++ ) {
       rec1 = rand();
       rec2 = rand();
       if ( rec1 != rec2 ){
          handle = DmGetRecord( msDB, rec1 );
          if ( ! handle ) {
             lastErr = DmGetLastErr();
          }
          handle2 = DmGetRecord( msDB, rec2 );
          if ( ! handle2 ) {
             lastErr = DmGetLastErr();
          }
          intPtr = MemHandleLock(handle);
   
          intPtr2 = MemHandleLock(handle2);
          MemMove((void *) &temp, intPtr, sizeof(UInt32) );
          DmWrite( intPtr, 0, (void *) intPtr2, sizeof(UInt32) );
          DmWrite( intPtr2, 0, (void *) &temp, sizeof(UInt32) );
          MemHandleUnlock(handle);
          MemHandleUnlock(handle2);
          DmReleaseRecord(msDB, rec1, false);
          DmReleaseRecord(msDB, rec2, false);
       }
//       DmMoveRecord( msDB, rec1, rec2);
   }
// get rid of database
   DmCloseDatabase(msDB);
   error = DmDeleteDatabase(0, fileID);
   
}

void memswapdb::srand(UInt32 newseed) {

     seedval = newseed;
}
UInt32 memswapdb::rand() {

     seedval = seedval * 1103515245 + 12345;
     return (seedval/65536) % ARRAYSIZE;
}
