#include "string.h"

string::string() {
   MemPtr init;
   _str = MemHandleNew(sizeof(Char));
   init = MemHandleLock(_str);
   StrCopy( (Char *) init, (Char *) "" );
   _len=0;
   MemHandleUnlock( _str );
}
string::~string() {
   if ( _str > 0 ) {
      MemHandleFree(_str);
   }
}

int string::length() {
   return _len;
}
void string::stringCpy(char *dest){       // copies string contents to dest
   Err error;
   MemPtr strfrom;
   strfrom = MemHandleLock(_str);
   StrCopy( dest, (char *) strfrom );
   error = MemHandleUnlock( _str );
}
    
   

string &string::operator=(string &s) {
   Err error;
   MemPtr strto;
   MemPtr strfrom;
   if ( this == &s ) { return *this; }
   if (_str != 0) { MemHandleFree(_str); }
   _str = MemHandleNew(s._len+1);
   strto = MemHandleLock(_str);
   strfrom = MemHandleLock(s._str);
   StrCopy( (char *) strto, (char *) strfrom );
   error = MemHandleUnlock( s._str );
   error = MemHandleUnlock( _str );
   _len=s._len;
   return *this;
}
string &string::operator=(char *strfrom) {
   Err error;
   MemPtr strto;
   int length;
   length=StrLen(strfrom);
   if (_str != 0) { MemHandleFree(_str); }
   _str = MemHandleNew(length+1);
   strto = MemHandleLock(_str);
   StrCopy( (char *) strto, strfrom );
   error = MemHandleUnlock( _str );
   _len=length;
   return *this;
}
string &string::operator+( string &s ) {
   UInt32 newlen;
   Err error;
   MemPtr strto;
   MemPtr strfrom;
   string temp;
   newlen=_len+s._len+1;
   if ( ! _str ) {
      _str = MemHandleNew( newlen );
   }
   else {
      error = MemHandleResize( _str, newlen );
   }
   strto = MemHandleLock(_str);
   strfrom = MemHandleLock(s._str);
   StrCat( (char *) strto, (char *) strfrom );
   error = MemHandleUnlock( s._str );
   error = MemHandleUnlock( _str );
   _len=newlen-1;
   return *this; 
}

string &string::operator+( char *strfrom ) {
   UInt32 newlen;
   Err error;
   MemPtr strto;
   string temp;
   UInt32 length;
   length=(UInt32) StrLen(strfrom);
   newlen=_len+length+1;
   if ( ! _str ) {
      _str = MemHandleNew( newlen );
   }
   else {
      error = MemHandleResize( _str, newlen );
   }
   strto = MemHandleLock(_str);
   StrCat( (char *) strto, strfrom );
   error = MemHandleUnlock( _str );
   _len=newlen-1;
   return *this; 
}

