/*
 * benchesMIDlet.java
 *
 * Created on September 2, 2002, 5:52 PM
 */
package benchmarks;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

/**
 * An example MIDlet with simple "Hello" text and an Exit command.
 * Refer to the startApp, pauseApp, and destroyApp
 * methods so see how each handles the requested transition.
 *
 * @author  root
 * @version
 */
public class benchesMIDlet extends MIDlet implements CommandListener {
    
    private Command exitCommand; // The exit command
    private static Display display;    // The display for this MIDlet
    private Form Form1;
    private ChoiceGroup benchchoice;
    private TextField Result;
    private Command goCommand;
    Sieve tprime;
    Memswap swapper;
    Memswapdb swapper2;
    public benchesMIDlet() {
        display = Display.getDisplay(this);
        exitCommand = new Command("Exit", Command.STOP, 2);
    }
    
    /**
     * Start up the Hello MIDlet by creating the TextBox and associating
     * the exit command and listener.
     */
    public void startApp() {
        benchchoice = new ChoiceGroup("Benchmark",ChoiceGroup.EXCLUSIVE);
        benchchoice.append("StackTest",null);
        benchchoice.append("Sieve",null);
        benchchoice.append("MemSwap",null);
        benchchoice.append("MemSwap DB",null);
        StringItem blankline = new StringItem(" "," ");
        goCommand = new Command("Go!",Command.SCREEN,2);
        Result=new TextField("Result: ","",25,TextField.ANY);
        Form1 = new Form("Benchmarks");
        Form1.addCommand(exitCommand);
        Form1.addCommand(goCommand);
        Form1.append(benchchoice);
        Form1.append(blankline);
        Form1.append(Result);
        Form1.setCommandListener(this);
        
        display.setCurrent(Form1);
    }
    
    /**
     * Pause is a no-op since there are no background activities or
     * record stores that need to be closed.
     */
    public void pauseApp() {
    }
    
    /**
     * Destroy must cleanup everything not handled by the garbage collector.
     * In this case there is nothing to cleanup.
     */
    public void destroyApp(boolean unconditional) {
    }
    
    /*
     * Respond to commands, including exit
     * On the exit command, cleanup and notify that the MIDlet has been destroyed.
     */
    public void commandAction(Command c, Displayable s) {
        String duration="";
        if (c == exitCommand) {
            destroyApp(false);
            notifyDestroyed();
        }
        if ( c == goCommand ) {
            int selected=benchchoice.getSelectedIndex();
            switch ( selected ){
                case 0:
                    stackTester stackt = new stackTester();
                    stackt.runBenchmark();
                    stackt=null;
                    break;
                case 1:
                    swapper=null;
                    swapper2=null;
                    if ( tprime == null ) { tprime = new Sieve(); }
                    tprime.runBenchmark();
                    duration=tprime.getDuration();
                    Result.setString( duration );
                    break;
                case 2:
                    swapper2=null;
                    tprime=null;
                    if (swapper == null ) { swapper = new Memswap(); }
                    duration="";
                    swapper.runBenchmark();
                    duration=swapper.getDuration();
                    Result.setString( duration );
                    break;
                case 3:
                    swapper=null;
                    tprime=null;
                    if (swapper2 == null) { swapper2 = new Memswapdb(); }
                    duration="";
                    swapper2.runBenchmark();
                    duration=swapper2.getDuration();
                    Result.setString( duration );
                    break;
            }
        }
    }

    
    public static Display getDisplay(){
        return display;
    }
}
